"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  PagesManager: true
};
exports.PagesManager = void 0;

var _builder = require("./builder");

Object.keys(_builder).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _builder[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _builder[key];
    }
  });
});

var _types = require("./types");

Object.keys(_types).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _types[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _types[key];
    }
  });
});

class PagesManager {
  fallbackHandler;

  constructor() {
    this.fallbackHandler = null;
  }

  get middleware() {
    return (context, next) => {
      var _context$messagePaylo, _context$eventPayload;

      context.pagesBuilder = () => new _builder.PagesBuilder({
        context
      });

      const builderId = (context === null || context === void 0 ? void 0 : (_context$messagePaylo = context.messagePayload) === null || _context$messagePaylo === void 0 ? void 0 : _context$messagePaylo.builder_id) || (context === null || context === void 0 ? void 0 : (_context$eventPayload = context.eventPayload) === null || _context$eventPayload === void 0 ? void 0 : _context$eventPayload.builder_id);

      if (builderId) {
        const pagesInstance = _builder.pagesStorage.get(builderId);

        if (pagesInstance) {
          pagesInstance.messageMiddleware(context);
        } else {
          if (this.fallbackHandler) {
            return this.fallbackHandler(context, next);
          }
        }
      }

      return next();
    };
  }
  /**
   * Функция для проверки наличия сборщика
   */


  static hasBuilder(builderId) {
    return _builder.pagesStorage.has(builderId);
  }
  /**
   * Метод для установки обработчика при отсутствии сборщика
   */


  onFallback(handler) {
    this.fallbackHandler = handler;
    return this;
  }

}

exports.PagesManager = PagesManager;