import { Context, IMessageContextSendOptions } from 'vk-io';
import { IPagesBuilderOptions } from './builder';
import { FunctionalKeyboard } from './keyboard';
export declare type ExtendedMessageContextOptions = IMessageContextSendOptions & {
    keyboard?: FunctionalKeyboard;
};
export declare type StringPage = string;
export declare type ObjectPage = ExtendedMessageContextOptions;
export declare type FunctionPage<C extends Context = Context> = (context: IPagesBuilderOptions<C>['context']) => (StringPage | ObjectPage | Promise<ObjectPage | StringPage>);
export declare type Page = StringPage | ObjectPage | FunctionPage;
export declare enum PageSendMethod {
    SEND = "send",
    EDIT = "editMessage"
}
export declare type PageSendMethodUnion = `${PageSendMethod}`;
export interface IAutoGeneratePagesOptions {
    items: (string | number)[];
    countPerPage?: number;
}
