"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.editMessage = editMessage;

var _vkIo = require("vk-io");

var _types = require("../types");

function editMessage(builder, messageParams, isStop) {
  const context = builder.sent;
  const isSendMethod = builder.sendMethod === _types.PageSendMethod.SEND;

  if (!context || isSendMethod && isStop) {
    return Promise.resolve();
  }

  return context[builder.sendMethod](messageParams).then(context => {
    if (isSendMethod && typeof context !== 'number') {
      builder.sent = context;
      builder.saveContext();
    }

    return context;
  }).catch(error => {
    if ((error === null || error === void 0 ? void 0 : error.code) === _vkIo.APIErrorCode.MESSAGES_EDIT_EXPIRED) {
      return context.send(messageParams).then(context => {
        builder.sent = context;
        builder.saveContext();
        return context;
      });
    }

    throw error;
  });
}